config/routes.rb
Rails.application.routes.draw do
  ## OAUTH ##
  devise_scope :user do
    get "omniauth/franceconnect/callback" => "omniauth_callbacks#franceconnect"
  end

  devise_for :super_admins # necessary for helpers like super_admin_signed_in?
  devise_scope :super_admin do
    get "omniauth/github/callback" => "omniauth_callbacks#github"
  end

  ## ADMIN ##
  get "connexion_super_admins", to: "welcome#super_admin"

  delete "super_admins/sign_out" => "super_admins/sessions#destroy"

  namespace :super_admins do
    resources :agents do
      get "sign_in_as", on: :member
      post :invite, on: :member
    end
    resources :super_admins
    resources :organisations
    resources :services
    resources :motifs
    resources :territories
    resources :users do
      get "sign_in_as", on: :member
    end
    root to: "agents#index"

    authenticate :super_admin do
      match "/delayed_job" => DelayedJobWeb, anchor: false, via: %i[get post]
    end
  end
  get "super_admin", to: redirect("super_admins", status: 301)

  devise_scope :user do
    get "users/pending_registration" => "users/registrations#pending"
    get "invitation", to: "users/invitations#invitation", as: "invitations_landing"
  end

  ## APP ##
  devise_for :users,
             controllers: { registrations: "users/registrations", sessions: "users/sessions", passwords: "users/passwords", confirmations: "users/confirmations", invitations: "users/invitations" }

  namespace :users do
    resource :rdv_wizard_step, only: %i[new create]
    resources :rdvs, only: %i[index create show edit update] do
      member do
        get :creneaux
        put :cancel
      end
    end
    resource :user_name_initials_verification, only: %i[new create], controller: "user_name_initials_verification"
    post "file_attente", to: "file_attentes#create_or_delete"
  end
  resources :stats, only: :index
  get "stats/agents", to: "stats#agents", as: "agents_stats"
  get "stats/organisations", to: "stats#organisations", as: "organisations_stats"
  get "stats/rdvs", to: "stats#rdvs", as: "rdvs_stats"
  get "stats/users", to: "stats#users", as: "users_stats"
  get "stats/receipts", to: "stats#receipts", as: "receipts_stats"
  get "stats/:departement", to: "stats#index", as: "departement_stats"

  authenticate :user do
    get "/users/informations", to: "users/users#edit"
    patch "users/informations", to: "users/users#update"
    resources :relatives, except: %i[index show], controller: "users/relatives"
  end
  authenticated :user do
    get "/users/rdvs", to: "users/rdvs#index"
  end

  devise_for :agents, controllers: {
    invitations: "admin/invitations_devise", # only using the accept route here
    sessions: "agents/sessions",
    passwords: "agents/passwords",
  }

  devise_scope :agent do
    get "agents/edit" => "agents/registrations#edit", as: "edit_agent_registration"
    put "agents" => "agents/registrations#update", as: "agent_registration"
    delete "agents" => "agents/registrations#destroy", as: "delete_agent_registration"
    namespace :agents do
      resource :preferences, only: %i[show update]
    end
  end

  namespace :api do
    namespace :v1 do
      mount_devise_token_auth_for "AgentWithTokenAuth", at: "auth"
      resources :absences, except: %i[new edit]
      resources :agents, only: %i[index]
      resources :users, only: %i[create index show update] do
        get :invite, on: :member
        post :invite, on: :member
      end
      resources :user_profiles, only: [:create]
      resources :organisations, only: %i[index] do
        resources :users, only: %i[index show]
        resources :motifs, only: %i[index]
        resources :rdvs, only: %i[index]
      end

      resources :invitations, param: "token", only: [:show]
    end
  end

  resources :organisations, only: %i[new create]

  authenticate :agent do
    namespace "admin" do
      resources :territories, only: %i[update show] do
        scope module: "territories" do
          resources :agent_territorial_roles, only: %i[index new create destroy]
          resources :agent_territorial_access_rights, only: %i[update]
          resources :webhook_endpoints, except: %i[show]
          resources :agents
          resources :teams do
            collection do
              get :search
            end
          end
          resource :user_fields, only: %i[edit update]
          resource :rdv_fields, only: %i[edit update]
          resource :motif_fields, only: %i[edit update]
          resource :sms_configuration, only: %i[show edit update]
          resources :zone_imports, only: %i[new create]
          resources :zones, only: [:index] # exports only
          resources :sectors do
            resources :zones
            resources :sector_attributions, only: %i[new create destroy], as: :attributions
            delete "/zones" => "zones#destroy_multiple"
          end
          get "sectorisation_test" => "sectorisation_tests#search"
        end
      end

      # Routes pour les ressources du calendrier.
      # TODO trouver un meilleur nom pour éviter la nécessité de ce commentaire :)
      resources :agents, only: [], module: :agents do
        resources :plage_ouvertures, only: [:index]
        resources :rdvs, only: [:index]
        resources :absences, only: [:index]
      end

      resources :organisations do
        resources :plage_ouvertures, except: %i[index new]
        resources :agent_searches, only: :index, module: "creneaux"
        resources :slots, only: :index
        resources :lieux, except: :show
        resources :motifs
        resources :rdvs_collectifs, only: %i[index new create edit update] do
          collection do
            resources :motifs, only: [:index], as: :rdvs_collectif_motifs, controller: "rdvs_collectifs/motifs"
          end
        end
        resources :rdvs, except: [:new] do
          post :new_participation
          collection do
            post :export
          end
        end
        scope module: "organisations" do
          resource :setup_checklist, only: [:show]
          resources :stats, only: :index do
            collection do
              get :rdvs
              get :users
            end
          end
        end
        resources :users do
          member do
            post :invite
            get :link_to_organisation
          end
          collection do
            get :search
          end
          resources :referents, only: %i[index create destroy]
        end
        resources :absences, except: %i[index show new]
        resources :agent_roles, only: %i[edit update]
        resources :agent_agendas, only: %i[show] do
          put :toggle_displays, on: :member
        end
        resources :agents, only: %i[index destroy] do
          resources :absences, only: %i[index new]
          resources :plage_ouvertures, only: %i[index new]
          resources :stats, only: :index do
            collection do
              get :rdvs
              get :users
            end
          end
        end
        resources :invitations, only: [:index] do
          post :reinvite, on: :member
        end
        resource :merge_users, only: %i[new create]
        resource :rdv_wizard_step, only: [:new] do
          get :create
        end
        devise_for :agents, controllers: { invitations: "admin/invitations_devise" }, only: :invitations
        get "support", to: "static_pages#support"
      end

      resources :jours_feries, only: [:index]
    end
  end
  authenticated :agent do
    root to: "admin/organisations#index", as: :authenticated_agent_root, defaults: { follow_unique: "1" }
  end

  { contact: "contact", mds: "mds", accessibility: "accessibility" }.each do |k, v|
    get v => "static_pages##{k}"
  end

  ## Shorten urls for SMS

  get "r", to: redirect("users/rdvs", status: 301), as: "rdvs_short"

  get "r/:id", to: (redirect do |path_params, req|
    query_params = format_redirect_params(req.params)
    "users/rdvs/#{path_params[:id]}#{query_params}"
  end), as: "rdv_short"

  get "prdv", to: (redirect do |_path_params, req|
    query_params = format_redirect_params(req.params)
    "prendre_rdv#{query_params}"
  end), as: "prendre_rdv_short"

  get "r/:id/cr", to: (redirect do |path_params, req|
    query_params = format_redirect_params(req.params)
    "users/rdvs/#{path_params[:id]}/creneaux#{query_params}"
  end), as: "creneaux_users_rdv_short"

  def format_redirect_params(params)
    # we rename the short parameter tkn
    params[:invitation_token] ||= params.delete(:tkn) if params[:tkn]
    params.delete(:id) # id is passed through path_params
    params.values.any? ? "?#{params.to_query}" : ''
  end

  ##

  get "accueil_mds" => "welcome#welcome_agent"
  post "/" => "welcome#search"
  get "departement/:departement", to: "welcome#welcome_departement", as: "welcome_departement"
  post "departement/:departement" => "welcome#search_departement"
  get "departement/:departement/:service", to: "welcome#welcome_service", as: "welcome_service"
  resources :lieux, only: %i[index show]
  root "welcome#index"

  get "/prendre_rdv", to: "search#search_rdv"

  # rubocop:disable Style/FormatStringToken
  # temporary route after admin namespace introduction
  get "/organisations/*rest", to: redirect('admin/organisations/%{rest}')
  # old agenda rule was bookmarked by some agents
  get "admin/organisations/:organisation_id/agents/:agent_id", to: redirect("/admin/organisations/%{organisation_id}/agent_agendas/%{agent_id}")
  # rubocop:enable Style/FormatStringToken

  # LetterOpener
  mount LetterOpenerWeb::Engine, at: "/letter_opener" if Rails.env.development?
end

app/controllers/admin/rdvs_collectifs/motifs_controller.rb
# frozen_string_literal: true

class Admin::RdvsCollectifs::MotifsController < AgentAuthController
  def index
    @motifs = policy_scope(Motif).available_motifs_for_organisation_and_agent(current_organisation, current_agent).collectif
  end
end

app/controllers/admin/rdvs_collectifs_controller.rb
# frozen_string_literal: true

class Admin::RdvsCollectifsController < AgentAuthController
  def index
    @motifs = policy_scope(Motif).available_motifs_for_organisation_and_agent(current_organisation, current_agent).collectif

    @rdvs = policy_scope(Rdv).where(organisation: current_organisation).collectif
    @rdvs = @rdvs.order(starts_at: :asc).page(params[:page])

    @form = Admin::RdvCollectifSearchForm.new(params.permit(:motif_id, :organisation_id, :from_date, :with_remaining_seats))

    @rdvs = @form.filter(@rdvs)
  end

  def new
    motif = policy_scope(Motif).find(params[:motif_id])
    @rdv = Rdv.new(organisation: current_organisation, motif: motif, duration_in_min: motif.default_duration_in_min)

    if params[:duplicated_rdv_id]
      duplicated_rdv = policy_scope(Rdv).find(params[:duplicated_rdv_id])

      new_rdv_attributes = duplicated_rdv.attributes.symbolize_keys.slice(*create_attribute_names)
      @rdv.assign_attributes(new_rdv_attributes)
      @rdv.agents = duplicated_rdv.agents
    end
    authorize(@rdv)
  end

  def create
    @rdv = Rdv.new(organisation: current_organisation, users_count: 0)
    authorize(@rdv, :new?)
    if @rdv.update(create_params)
      Notifiers::RdvCreated.perform_with(@rdv, current_agent)
      flash[:notice] = "#{@rdv.motif.name} créé"
      redirect_to admin_organisation_rdvs_collectifs_path(current_organisation)
    else
      render :new
    end
  end

  def edit
    @rdv = Rdv.find(params[:id])

    authorize(@rdv)

    @add_user_ids = params[:add_user].to_a + params[:user_ids].to_a
    users_to_add = User.where(id: @add_user_ids)
    @rdv_users_to_add = users_to_add.ids.map { @rdv.rdvs_users.build(user_id: _1) }
  end

  def update
    @rdv = Rdv.find(params[:id])
    authorize(@rdv, :update?)

    previous_participant_ids = @rdv.participants_with_life_cycle_notification_ids

    if @rdv.update(update_users_params)
      flash[:notice] = "Participants mis à jour"
      Notifiers::RdvCollectifParticipations.perform_with(@rdv, current_agent, previous_participant_ids)
      redirect_to admin_organisation_rdvs_collectifs_path(current_organisation)
    else
      render :edit
    end
  end

  private

  def create_attribute_names
    %i[starts_at duration_in_min lieu_id name max_participants_count context motif_id]
  end

  def create_attributes_rdvs
    [agent_ids: [], lieu_attributes: %i[name address latitude longitude]]
  end

  def create_params
    allowed_params = params.require(:rdv).permit(*create_attribute_names, *create_attributes_rdvs)
    return allowed_params if params[:rdv][:lieu_id].present?

    allowed_params.to_h.deep_merge(lieu_attributes: { organisation: current_organisation, availability: :single_use })
  end

  def update_users_params
    params.require(:rdv).permit(
      user_ids: [],
      rdvs_users_attributes: %i[user_id send_lifecycle_notifications send_reminder_notification id _destroy]
    )
  end
end

app/views/admin/rdvs_collectifs/_participants_info.html.slim
.d-flex.card-text.mb-2
    div.mr-1
      i.fa.fa-fw.fa-users>
    = I18n.t("rdvs.participants", count: rdv.users_count)

.d-flex.card-text.mb-3
  - if rdv.remaining_seats?
      div.mr-3
      div
        - if rdv.max_participants_count
          = I18n.t("rdvs.available_seats", count: rdv.max_participants_count - rdv.users_count)
        - else
          = "Pas de limite de places"
  - elsif rdv.fully_booked?
      div.mr-1
        i.fa.fa-fw.fa-user-check>
        = "Complet"
  - elsif rdv.overbooked?
    div.mr-1
      i.fa.fa-fw.fa-user-times>
      = "Trop de participants (#{rdv.users_count} personnes pour #{I18n.t('rdvs.seats', count: rdv.max_participants_count)})"

app/views/admin/rdvs_collectifs/_rdv.html.slim
.card
  .card-header
    = link_to admin_organisation_rdv_path(rdv.organisation, rdv) do
      h5= rdv_title_for_agent(rdv)
    = I18n.l(rdv.starts_at, format: "%A %d %B à %H:%M").capitalize
  .card-body
    .row
      .col-md-6
        .d-flex.card-text.mb-2
          div.mr-1
            i.fa.fa-fw.fa-map-marker-alt>
            = rdv.lieu.name

        .d-flex.card-text.mb-2
          div.mr-1
            i.fa.fa-fw.fa-user>
            strong> Animé par
            = agents_to_sentence(rdv.agents)

        .d-flex.card-text
          div.mr-1
            i.fa.fa-fw.fa-clock>
            = "#{rdv.duration_in_min} minutes"

      .col-md-6
        = render "admin/rdvs_collectifs/participants_info", rdv: rdv
        - if rdv.remaining_seats?
          = link_to edit_admin_organisation_rdvs_collectif_path(rdv.organisation, rdv), class: "d-flex card-text mb-2" do
            div.mr-1
              i.fa.fa-fw.fa-user-plus>
            div
              = "Ajouter un participant"

app/views/admin/rdvs_collectifs/edit.html.slim
- content_for(:title) { "Ajouter un participant" }

.row.justify-content-md-center
  .col-md-8
    = simple_form_for(@rdv, url: admin_organisation_rdvs_collectif_path(current_organisation), method: :put) do |f|
      .card
        .card-header
          h3.text-center #{@rdv.motif.name} (#{@rdv.motif.service.short_name})
        .card-body.px-3
          .row.mt-3
            .col-md-6
              .d-flex.card-text.mb-2
                div.mr-1
                  i.fa.fa-fw.fa-users>
                div
                  - if @rdv.max_participants_count
                    = I18n.t("rdvs.seats", count: @rdv.max_participants_count)
                  - else
                    = "Pas de limite de places"

              .d-flex.card-text.mb-3
                div.mr-1
                  i.fa.fa-fw.fa-users>
                div
                  = I18n.t("rdvs.participants", count: @rdv.users_count)
                  ul
                    - @rdv.users.each do |user|
                      li= user.full_name

            .col-md-6
              .d-flex.card-text.mb-2
                - if @rdv.phone?
                    i.fa.fa-fw.fa-phone>
                    | RDV téléphonique
                - else
                  div.mr-1
                    i.fa.fa-fw.fa-map-marker-alt>
                    - if @rdv.home?
                      | RDV à domicile
                      = human_location(@rdv)
                    - elsif @rdv.public_office?
                      = @rdv.lieu.name

              .d-flex.card-text.mb-2
                div.mr-1
                  i.fa.fa-fw.fa-user>
                div
                  strong> Animé par
                  = agents_to_sentence(@rdv.agents)

              .d-flex.card-text
                div.mr-1
                  i.fa.fa-fw.fa-clock>
                div
                  = "#{@rdv.duration_in_min} minutes"

        .card-footer.px-3
          = render "model_errors", model: @rdv

          .form-group
            = "Usager à inscrire :"
            = f.fields_for :rdvs_users, @rdv_users_to_add do |rdv_user_form|
              = render "admin/rdvs_users/form", form: rdv_user_form

          .form-group
            = select_tag :status,
                    options_for_select([]),
                    include_blank: "Ajouter un usager",
                    required: false,
                    class: "select2-input js-rdv-user-select",
                    data: { \
              width: "auto", \
              "scroll-to-bottom": @add_user_ids.present?, \
              "select-options": { ajax: { url: search_admin_organisation_users_path(current_organisation, exclude_ids: @rdv.rdvs_users.map(&:user_id)), dataType: "json", delay: 250 } }, \
             }
            span.small.text-muted
              | L'usager n'existe pas ?&nbsp;
              = link_to \
                "Créer un usager", \
                new_admin_organisation_user_path( \
                  current_organisation, modal: true, return_location: edit_admin_organisation_rdvs_collectif_path(current_organisation, @rdv, add_user: @add_user_ids), role: default_service_selection_from(@rdv.motif.service) \
                    ), \
                data: { modal: true }

          .text-right
            = link_to t("helpers.back"), admin_organisation_rdvs_collectifs_path(current_organisation), class: "btn btn-link"
            = f.button :submit, t("helpers.submit.submit")

app/views/admin/rdvs_collectifs/index.html.slim
- content_for :title do
  | RDV Collectifs

- content_for(:menu_item) { "menu-rdvs-collectifs-list" }

- content_for :breadcrumb do
  .btn-group
    = link_to "Nouveau RDV Collectif", admin_organisation_rdvs_collectif_motifs_path(current_organisation), class: "btn btn-primary"

.card
  .card-body
    = simple_form_for(@form, as: "", url: admin_organisation_rdvs_collectifs_path(current_organisation), method: :get) do |f|
      .row
        .col-md-4
          = date_input(f, :from_date, label = "À partir du", value: @form.from_date)
        .col-md-4
          = f.input :motif_id, \
            include_blank: true, \
            collection: @motifs, \
            as: :select, \
            label_method: -> { motif_name_with_location_type(_1) }, \
            input_html: { \
              data: { placeholder: "Sélectionnez un motif", "allow-clear": true }, \
              class: "select2-input", \
            }
        .col-md-3.mt-4
          = f.input :with_remaining_seats, as: :boolean, label: "Avec des places disponibles"
        .col-md-1.d-flex-justify-content-end.mt-3
          = f.submit "Filtrer", class: "btn btn-outline-primary"

.row.justify-content-center.pb-3
  .col-md-8
    - if @rdvs.any?
      = render(partial: "admin/rdvs_collectifs/rdv",
              collection: @rdvs.includes(:organisation, :users, :lieu, :motif, agents: :service),
              locals: {show_user_details: false},
              cached: ->(rdv) { [rdv, false, locale_cache_key] })
      .d-flex.justify-content-center= paginate @rdvs, theme: "twitter-bootstrap-4"
    - else
      .card
        .card-body
          .row.justify-content-md-center
            .col-md-6.text-center.my-5
              p.mb-2.lead
                | Aucun RDV
              span.fa-stack.fa-4x
                i.fa.fa-circle.fa-stack-2x.text-primary
                i.far.fa-calendar.fa-stack-1x.text-white

app/views/admin/rdvs_collectifs/new.html.slim
- content_for(:title) { "Nouveau RDV Collectif" }

- content_for :breadcrumb do
  ol.breadcrumb.m-0
    li.breadcrumb-item
      = link_to "RDV Collectifs", admin_organisation_rdvs_collectifs_path(current_organisation)
    li.breadcrumb-item.active Nouveau RDV Collectif

.row.justify-content-md-center
  .col-md-8
    = simple_form_for(@rdv, url: admin_organisation_rdvs_collectifs_path(current_organisation), method: :post) do |f|
      .card
        .card-header
          h3.text-center #{@rdv.motif.name} (#{@rdv.motif.service.short_name})
        .card-body.px-3
          = render "model_errors", model: @rdv

          .form-row
            .col-md-6= datetime_input(f, :starts_at)
            .col-md-6= f.input :duration_in_min, as: :integer
          = f.association :agents, collection: @rdv.motif.authorized_agents.includes(:service), label_method: :reverse_full_name_and_service, input_html: { multiple: true, class: "select2-input" }
          = f.input :name, wrapper_html: { class: "mb-1" }
          p.text-muted.font-14= I18n.t("activerecord.attributes.rdv/name.hint")

          = f.input :context
          = f.hidden_field :motif_id, value: @rdv.motif_id
          - new_lieu_record = @rdv.lieu&.new_record?
          - controller_data = { "controller": "rdv-lieu",
                  "initial-state": (new_lieu_record ? "single_use" : "existing"),
                  "select-placeholder-single-use-lieu": t(".select_placeholder_single_use_lieu"),
                  "select-placeholder-existing-lieu": t(".select_placeholder_existing_lieu"), }
          .form-group data=controller_data
            = f.label :lieu, required: true
            fieldset
              = f.association :lieu, collection: policy_scope(Lieu).enabled.ordered_by_name, label_method: :full_name,
                label: false,  include_blank: true,  required: false,
                input_html: { class: "select2-input", data: { "rdv-lieu-target": "existing_lieu_select", placeholder: ""} }
              small.form-text.text-muted data={"rdv-lieu-target": "new_lieu_link"}
                = t(".single_use_lieu_hint_html")
            fieldset data={ "rdv-lieu-target": "new_lieu_fieldset" }
              .border.p-2.bg-light
                = f.fields_for :lieu, (new_lieu_record ? @rdv.lieu : Lieu.new) do |f2|
                  = render "admin/lieux/lieu_fields", f: f2
              small.form-text.text-muted data={"rdv-lieu-target": "select_lieu_link"}
                = t(".existing_lieu_hint_html")

          = f.input :max_participants_count, input_html: { min: 1 }

          .d-flex.justify-content-end
            .btn-group
              = f.button :submit, t("helpers.submit.submit")